
Core - Feature # 18211

Status: Resolved Priority: Should have
Author: Robert Destigter Category: FormEngine aka TCEforms
Created: 2008-02-14 Assigned To:
Updated: 2013-04-11 Due date:
PHP Version: 5.3
Complexity: medium
Sprint Focus:
Subject: Array of display conditions for TCA fields instead of 1 string
Description

I think that the option "displayCond" should be an array of conditions instead of just one string.

'displayCond' => Array (
     "FIELD:myfieldname:!=:myvalue",
     "FIELD:myfieldname:IN:4,5,6",
),

(issue imported from #M7531)

Related issues:
related to Core - Bug # 37938: Using HTML5 for audio not (easily) possible du... New 2012-06-12
related to TCA Reference - Task # 57479: Document TCA DisplayCond Closed 2014-04-01
related to TCA Reference - Feature # 46819: Support multiple display conditio... Closed 2013-03-31
duplicated by Core - Feature # 37939: displayCond should allow multiple condi... Resolved 2012-06-12

Associated revisions
Revision fe3e0a80 - 2013-03-31 17:02 - Jigal van Hemert

[FEATURE] Support multiple display conditions in TCA

The displayCond option is expanded with support for multiple
conditions and even the logical operators OR and AND.

Change-Id: I6cb38ef83093ed7399b47701e234ac13bdfa47dd
Fixes: #18211
Releases: 6.1
Reviewed-on: https://review.typo3.org/13508
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History
#1 - 2009-06-26 22:41 - Ralf Hettinger
I'm in the need for a similar thing, though it is a bit more complex here. So I decided to come up with the attached patch, which allows grouping by AND
or OR and works recursively... the following example reads

displayCond true if
(my_field1 &&
 my_field2!=3 &&
 (my_field3 || my_field4 || my_field5 && my_field6) ||
 my_field7 ||
 my_field8
)

[...]
'displayCond' => array (
  'AND' => array (
    'FIELD:my_field1:REQ:true',
    'FIELD:my_field2:!=:3',
    'OR' => array (
      'FIELD:my_field3:REQ:true',
      'FIELD:my_field4:REQ:true',
      'AND' => array(
        'FIELD:my_field5:REQ:true',
        'FIELD:my_field6:REQ:true',
      )
    )
  ),
  'OR' => array (
    'FIELD:my_field7:REQ:true',
    'FIELD:my_field8:REQ:true',
  )
),
[...]

#2 - 2009-06-26 22:47 - Ralf Hettinger

forgot to mention: patched against 4.3 trunk rev. 5639

#3 - 2011-05-17 12:50 - Steffen Müller

any news here. is this still an issue? would be nice to have this feature

#4 - 2011-07-14 13:54 - Xavier Perseguers
- Target version changed from 4.6.0 to 4.6.0-beta1

#5 - 2011-08-02 18:05 - Xavier Perseguers
- Target version deleted (4.6.0-beta1)

#6 - 2011-11-30 14:10 - Stefano Cecere

@Xavier: why did you drop this feature? i just checked it and seems ok (and useful)
should we propose it to 4.7?
#7 - 2012-03-08 10:41 - Gabriel Kaufmann / Typoworx NewMedia

Stefano Cecere wrote:

@Xavier: why did you drop this feature? i just checked it and seems ok (and useful)
should we propose it to 4.7?

I also agree that this feature could be very useful! Why isn't this feature going into the core?

#8 - 2012-04-12 18:08 - Michael Sollmann

4.8?

#9 - 2012-05-13 15:38 - Robert Wildling

I'd like to join the credo! Please get it into core! Thanks!

#10 - 2012-06-12 11:23 - Stefan Neufeind

Haven't taken a look at the actual implementation. But yes, it would be really great to be able to combine multiple conditions.
Since 4.8 will be called 6.0 now, maybe for 6.0? :-)

#11 - 2012-06-26 09:18 - Jigal van Hemert
- Category set to FormEngine aka TCEforms
- Status changed from New to Accepted
- Target version set to 6.0.0-alpha3
- Complexity set to medium

Seems like a useful feature. Anyone who wants to push a patch to gerrit?

#12 - 2012-06-26 17:50 - Helmut Hummel
- Status changed from Accepted to Needs Feedback

How about introducing a USERFUNC: option?

Would that serve your needs. The proposed array solution looks complex and there will be edge cases which still cannot be covered

#13 - 2012-06-26 20:54 - Stefan Neufeind

USERFUNC for complex scenarios might be good to have. But imho we should have something built in as was proposed with that patch (though it
looks complex at first). But I think for some small AND/OR it's more handy to have that builtin than through a USERFUNC whenever you need it.

Also note that USERFUNC might work on the server-side - but we have it on the client (JS) as well (flexform with displayCond).
#14 - 2012-08-07 23:51 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13508

#15 - 2012-10-25 15:32 - Ralf Hettinger
- File T3X_andor_tca_conditions-0_1_0-z-201210251526.t3x added

As author of this patch some years ago I'm hereby adding my vote for it ... :)

I haven't needed this neat feature for quite a while - as until today. The feature is tested in a productive environment since 3 years without any failures;
the patch is  still applying to 4.7.
For those who need a quick&dirty solution (like me today), I uploaded an extension which XClasses t3lib_tceforms (please forgive me, dear TYPO3
gods ;) )

#16 - 2012-10-25 16:27 - Gabriel Kaufmann / Typoworx NewMedia

You've also got my positive vote ;-)

Ralf Hettinger wrote:

As author of this patch some years ago I'm hereby adding my vote for it ... :)

For those who need a quick&dirty solution (like me today), I uploaded an extension which XClasses t3lib_tceforms (please forgive me, dear TYPO3
gods ;) )

May be there is any processing-hook that may be suiteable for adding the patch?

I think this patch is a must-have to go into the TYPO3-Core.

#17 - 2013-01-13 19:07 - Helmut Hummel
- Target version changed from 6.0.0-alpha3 to 6.0.1

#18 - 2013-02-08 10:59 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13508

#19 - 2013-02-08 11:01 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13508
#20 - 2013-02-15 13:59 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13508

#21 - 2013-02-18 11:54 - Gabriel Kaufmann / Typoworx NewMedia

Is there any plan to finally integrate multiple displayCond into the "final" TYPO3-Core anytime?

More complex TYPO3-Plugin make it really neccessary to integrate such a feature! And for now the only "Hack" ist to locally patch or XClass TYPO3 to
get it working. Neither the one nore the other of these is really good to handle.

Please let us know when this feature will be going to be finally reviewed and integrated into TYPO3-Core.

#22 - 2013-03-04 04:00 - Ingo Renner

Gabriel, if you want this feature so much, why is there no review from you?

#23 - 2013-03-04 10:42 - Gabriel Kaufmann / Typoworx NewMedia

Ingo Renner wrote:

Gabriel, if you want this feature so much, why is there no review from you?

Well what can I say much more. I think there have been enough suggestions how to implement this feature. I would prefer the Array-Way combined
with the possibility for a userFunc for more complex matches. The userFunc-Method would also keep the door's open for further matching-patterns
that may be implemented into core later on.

#24 - 2013-03-31 14:17 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13508

#25 - 2013-03-31 16:49 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/13508

#26 - 2013-03-31 17:03 - Christian Kuhn
- Target version changed from 6.0.1 to 6.1.0-beta1
- PHP Version changed from 5.0 to 5.3

#27 - 2013-03-31 17:30 - Jigal van Hemert
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:fe3e0a805e45478130fc75542a6db1da4b3e1aa4.

#28 - 2013-03-31 20:45 - Steffen Müller

Thanks a lot for merging this.

Does this also work in flexforms? If so, could you please give us an example?

#29 - 2013-04-11 18:07 - Stefan Froemken

Steffen Müller wrote:

Thanks a lot for merging this.

Does this also work in flexforms? If so, could you please give us an example?

Yes it also works in FlexForms. I just have created a documentation in german. At the bottom you see a nested example how to use this cool new
feature in FlexForms.

Link: http://jweiland.net/typo3/extension-programmierung/displaycond.html

Stefan

Files
7531.patch 3 kB 2009-06-26 Administrator Admin
7531_doc_core_api_wiki.txt 1.5 kB 2009-08-08 Administrator Admin
7531_4.3_cgl_v2.patch 3 kB 2009-08-08 Administrator Admin
T3X_andor_tca_conditions-0_1_0-z-201210251526.t3x 4 kB 2012-10-25 Ralf Hettinger
